using Articy.Unity;
using Articy.Unity.Interfaces;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ArticyStoryline : MonoBehaviour, IArticyFlowPlayerCallbacks {
    public IList<Branch> currentBranches;
    
    //previously ApplyTransition
    public void OnFlowPlayerPaused(IFlowObject currentNode) {
        var dialogueBox = GetComponent<DialogueBox>();
        
        var objWithText = currentNode as IObjectWithText;
        if (objWithText != null) 
            dialogueBox.SetText(objWithText.Text);

        var objSpeaker = currentNode as IObjectWithSpeaker;
        if (objSpeaker != null) {
            var speakerDisplayName = objSpeaker.Speaker as IObjectWithDisplayName;
            dialogueBox.SetActor(speakerDisplayName.DisplayName);
        }
        else
            dialogueBox.SetActor(string.Empty);

    }

    public void OnBranchesUpdated(IList<Branch> branches) {
        currentBranches = branches;
        GetComponent<DialogueBox>().SetTransitions(currentBranches);
    }

    public void ApplyTransition(int count) {
        GetComponent<DialogueBox>().ClearUI();
        GetComponent<ArticyFlowPlayer>().Play(currentBranches[count]);
    }
}
